meal_plans/urls.py
from django.urls import path


from meal_plans.views import (
  MealPlanCreateView,
  MealPlanListView,
  MealPlanUpdateView,
  MealPlanDetailView,
  MealPlanDeleteView,
)

urlpatterns = [
    path("", MealPlanListView.as_view(), name="meal_plans_list"),
    path("<int:pk>/", MealPlanDetailView.as_view(), name="meal_plans_detail"),
    path("<int:pk>/delete/", MealPlanDeleteView.as_view(), name="meal_plans_delete"),
    path("new/", MealPlanCreateView.as_view(), name="meal_plans_new"),
    path("<int:pk>/edit/", MealPlanUpdateView.as_view(), name="meal_plans_edit"),
    # path("<int:recipe_id>/ratings/", log_rating, name="recipe_rating"),
]

scrumptious/urls.py
from django.contrib import admin
from django.urls import include, path, reverse_lazy
from django.views.generic.base import RedirectView
from django.contrib.auth import views as auth_views

urlpatterns = [
    path("admin/", admin.site.urls),
    path("recipes/", include("recipes.urls")),
    path("tags/", include("tags.urls")),
    path("meal_plans/", include("meal_plans.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("recipes_list")),
        name="home",
    ),
    path("accounts/login/", auth_views.LoginView.as_view(), name="login"),
    path("accounts/logout/", auth_views.LogoutView.as_view(), name="logout"),
]

tags/urls.py
from django.urls import path

from tags.views import (
    TagListView,
    TagDeleteView,
    TagDetailView,
    TagCreateView,
    TagUpdateView,
)

urlpatterns = [
    path("", TagListView.as_view(), name="tags_list"),
    path("<int:pk>/", TagDetailView.as_view(), name="tag_detail"),
    path("<int:pk>/delete/", TagDeleteView.as_view(), name="tag_delete"),
    path("new/", TagCreateView.as_view(), name="tag_new"),
    path("<int:pk>/edit/", TagUpdateView.as_view(), name="tag_edit"),
]

meal_plans/models.py
from django.db import models
# from django.core.validators import MaxValueValidator, MinValueValidator

# from django.contrib.auth.models import User
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL

# Create your models here.


class MealPlan(models.Model):
    name = models.CharField(max_length=120)
    date = models.DateTimeField() # how to enter a future date?, not needed?
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="meal_plans",
        on_delete=models.CASCADE,
        null=True,
    )
    recipes = models.ManyToManyField("recipes.Recipe", related_name="meal_plans")


    def __str__(self):
        return self.name

meal_plans/views.py
from django.shortcuts import render
from django.shortcuts import redirect
from django.urls import reverse_lazy
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin

# from recipes.forms import RatingForm

from meal_plans.models import MealPlan



# Create your views here.


class MealPlanListView(ListView):
    model = MealPlan
    template_name = "meal_plans/list.html"
    paginate_by = 2
    # context_object_name = "meal_plans"

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class MealPlanDetailView(DetailView):
    model = MealPlan
    template_name = "meal_plans/detail.html"

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)

    # def get_context_data(self, **kwargs):
    #     context = super().get_context_data(**kwargs)
    #     context["rating_form"] = RatingForm()
    #     return context


class MealPlanCreateView(LoginRequiredMixin, CreateView):
    model = MealPlan
    template_name = "meal_plans/new.html"
    fields = ["name", "date", "recipes"] # add owner ???
    success_url = reverse_lazy("meal_plans_list")

    def form_valid(self, form):
        # here we overwrite the form_valid from the parent class
        form.instance.owner = self.request.user
        # self refers to the class RecipeCreateView
        return super().form_valid(form)
        # continues on to do what the parent class would do (ie CreateView)

    def form_valid(self, form):
        plan = form.save(commit=False)
        plan.owner = self.request.user
        plan.save()
        form.save_m2m()
        return redirect("meal_plans_detail", pk=plan.id)

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class MealPlanUpdateView(LoginRequiredMixin, UpdateView):
    model = MealPlan
    template_name = "meal_plans/edit.html"
    fields = ["name", "date", "recipes"]
    success_url = reverse_lazy("meal_plans_list")

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)

class MealPlanDeleteView(LoginRequiredMixin, DeleteView):
    model = MealPlan
    template_name = "meal_plans/delete.html"
    success_url = reverse_lazy("meal_plans_list")

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)

meal_plans/templates/meal_plans/delete.html
{% extends 'base.html' %} {% block content %}
<main>
  <div class="delete-form">
    <form method="post">
      {% csrf_token %}
      <p>Are you sure you want to delete "{{ mealplan }}"?</p>
      {{ form.as_p }}
      <div>
        <button class="button">Delete</button>
      </div>
    </form>
  </div>
</main>
{% endblock content %}

meal_plans/templates/meal_plans/detail.html
{% extends 'base.html' %} {% block content %} {% load markdownify %}

<main class="recipe-detail">
  <div>
    <a href="{% url 'meal_plans_edit' mealplan.id %}">Edit</a>
    <a href="{% url 'meal_plans_delete' mealplan.id %}">Delete</a>
  </div>
  <div class="recipe-detail-more">
    <div class="recipe-title">
      <h1>Recipes for {{ mealplan.name }} on {{mealplan.date}}</h1>
      <p>
        {% for recipe in mealplan.recipes.all %}
        <a href="{% url "recipe_detail" recipe.pk %}">
        <p>{{ recipe.name }}</p></a> {% endfor %}
      </p>
    </div>
  </div>
</main>

{% endblock content %}

meal_plans/templates/meal_plans/edit.html
{% extends 'base.html' %} {% block content %}

<main class="recipe-form">
  <form method="post">
    {% csrf_token %} {{ form.as_p }}
    <div class="control">
      <button class="button">Update</button>
    </div>
  </form>
</main>

{% endblock content %}

meal_plans/templates/meal_plans/list.html
{% extends 'base.html' %} {% block pagination %}
<div class="pagination">
  <span class="step-links">
    {% if page_obj.has_previous %}
    <a href="?page=1">&laquo; first</a>
    <a href="?page={{ page_obj.previous_page_number }}">previous</a>
    {% endif %}

    <span class="current">
      Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
    </span>

    {% if page_obj.has_next %}
    <a href="?page={{ page_obj.next_page_number }}">next</a>
    <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
    {% endif %}
  </span>
</div>
<div><a href={% url "meal_plans_new" %}>create</a></div>
{% endblock pagination %}


{% block content %}
<main class="recipe-grid">
  {% for banana in mealplan_list %}
  {% comment %} meal_plan: variable defined by the for loop {% endcomment %}
  {% comment %} mealplan_list : refers to the name of the model {% endcomment %}
  {% comment %} we changed the default name in the ListView class (see views.py) - reversed this back to DEFAULT name{% endcomment %}
  <div class="recipe-card">
    <h2 class="recipe-card-title">
      <a href="{% url 'meal_plans_detail' banana.pk %}"
      {% comment %} meal_plans_detail: name assigned to the url path {% endcomment %}
        >{{ banana.name }}</a>
    </h2>
      <p>
        {% for recipe in banana.recipes.all %}
        <p><a href="{% url "recipe_detail" recipe.pk %}">
        {{ recipe.name }}</a></p>
        {% endfor %}
      </p>
  </div>
  {% endfor %}

</main>

{% endblock content %}

meal_plans/templates/meal_plans/new.html
{% extends 'base.html' %} {% block content %}

<main class="recipe-form">
  <form method="post">
    {% csrf_token %} {{ form.as_p }}
    <div class="control">
      <button class="button">Create</button>
    </div>
  </form>
</main>

{% endblock content %}